#include <iostream.h>
#include <fstream.h>
#include <sys\timeb.h>
#include <ctype.h>
#include "work1.h"

const int n = 128;

static char lexeme[n]; // ⥪ ᥬ

static Tab tab(10, new Storage(1024)); // ⠡ 

int scan(istream &in)
  {
    // ᪠: ନ   室 ⮪
    // 0  砥 㤠

    unsigned char c;
    while (!in.eof()) //    뢠
      {
	c = in.get();
	if (isalpha(c) || c == '_') // ᫨ 砫 ᨬ 
	  {
	    char *s = lexeme;

	    //    lexeme
	    do
	      {
		*s++ = c;
	        c = in.get();
	      }
	    while (!in.eof() && (isalnum(c) || c == '_'));

	    *s = 0; // 騩 0

	    // 頥 ᫥ ⠭ ᨬ  ⮪
	    if (!in.eof()) in.putback(c);

	    return 1;  // ᯥ

          }

      } // while (!in.eof())

    return 0; // 㤠
  }

int main()
  {
    cout << "\n  䠩  ᮧ ⠡ : ";
    char name[n];
    cin >> name;
    ifstream fin(name); // 뢠 室 䠩
    if (!fin)
      {
        cerr << "  !";
        return 0;
      }

    struct timeb start_time, stop_time;
    Name *n;

    ftime(&start_time);
    while (scan(fin))
      if (n = tab.lookup(lexeme)) // 塞 ⠡
        n->count++;
      else tab.insert(lexeme);

    ftime(&stop_time);

    fin.close(); // 뢠 室 䠩

    // 뢠 ६ 믮
    int sec  = stop_time.time - start_time.time;
    int msec = stop_time.millitm - start_time.millitm;
    if (msec < 0)
      {
        msec += 1000;
        sec--;
      }

    ofstream fout("incltab.txt"); // 뢠 室 䠩
    if (!fout)
      {
        cerr << " ᮧ 室 䠩!";
        return 0;
      }

    fout << tab; // 뢮 ⠡
    cout << "\n :\n" << tab;

    fout.close(); // 뢠 室 䠩

    cout << "\n६ ᮧ ⠡: ";
    cout << sec << "."<< msec << "\n";

    cout << "\n  䠩  㤠   ⠡: ";
    cin >> name;
    fin.open(name); // 뢠 䠩  㤠 
    if (!fin)
      {
        cerr << "  !";
        return 0;
      }

    ftime(&start_time);
    while (scan(fin))
      tab.remove(lexeme); // 㤠塞   ⠡

    ftime(&stop_time);

    fin.close(); // 뢠 室 䠩

    // 뢠 ६ 믮
    sec  = stop_time.time - start_time.time;
    msec = stop_time.millitm - start_time.millitm;
    if (msec < 0)
      {
        msec += 1000;
        sec--;
      }

    fout.open("deltab.txt"); // 뢠 室 䠩
    if (!fout)
      {
        cerr << " ᮧ 室 䠩!";
        return 0;
      }

    fout << tab; // 뢮 ⠡
    cout << "\n :\n" << tab;

    fout.close(); // 뢠 室 䠩

    cout << "\n६ 㤠   ⠡: ";
    cout << sec << "."<< msec << endl;

    return 0;
  }
