

/******************************************************************
 synt.c
******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "main_c.h"
#include "main_t.h"
#include "main_e.h"

int find(char*);     //      
struct node* incl(char*);    //     
void del(void);      //    
void output(FILE*);  //        
void nxl(void);
void er(int);

int decl(void);
int oper(struct INSTR_LIST**);

int program(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  struct INSTR_LIST *tmpInstrListPtr = NULL;
  _0:
    if(lc==KWBEGIN) {nxl(); goto _1;}
    return 0;
  _1:
    if(decl()) {goto _2;}
    if(oper(&tmpInstrListPtr)) {
      //  ᯨ᪠    㦥  ᯨ
      INSTR_LIST_cat(iListPtrPtr, tmpInstrListPtr);
      goto _2;
    }
    er(4); return 0;
  _2:
    if(lc==PCL) {nxl(); goto _1;}
    if(lc==KWEND) {nxl(); goto _end;}
    er(4); return 0;
  _end:
    return 1;
}

int decl() {
  struct node* varyable[256];
  int i = -1; // 㪠⥫    ᨢ varyable
  _0:
    if(lc==KWVAR) {nxl(); goto _1;}
    return 0;
  _1:
    if(lc==ID) { // 䨪 뢠 ६
      if(!find(lv)) { //  ⢨ ᠭ ६ ନ㥬 
	varyable[++i] = incl(lv);
      } else {
	er(19); return 0;
      }
      nxl(); goto _2;
    }
    er(5); return 0;
  _2:
    if(lc==LSB) {nxl(); goto _3;}
    if(lc==CL) { // । ᪠ୠ ६ - ࠧ = 0
      varyable[i]->val.appl.len = 0;
      nxl(); goto _1;
    }
    if(lc==DVT) { // । ᪠ୠ ६ - ࠧ = 0
      varyable[i]->val.appl.len = 0;
      nxl(); goto _6;
    }
    er(5); return 0;
  _3:
    if(lc==INT) {//  ᨢ
      varyable[i]->val.appl.len = unum;
      nxl(); goto _4;
    }
    er(5); return 0;
  _4:
    if(lc==RSB) {nxl(); goto _5;}
    er(5); return 0;
  _5:
    if(lc==CL) {nxl(); goto _1;}
    if(lc==DVT) {nxl(); goto _6;}
    er(5); return 0;
  _6:
    if(lc==KWINT) {
      int j; //   ॡ  ६   ⨯
      for(j = 0; j <= i; ++j) {
	varyable[j]->val.appl.typ = INTTYP;
	varyable[j]->val.appl.addr = memAddr;
	if(varyable[j]->val.appl.len == 0)
	  memAddr += 2;
	else
	  memAddr += 2*varyable[j]->val.appl.len;
      }
      nxl(); goto _end;
    }
    if(lc==KWFLOAT) {
      int j; //   ॡ  ६   ⨯
      for(j = 0; j <= i; ++j) {
	varyable[j]->val.appl.typ = FLOATTYP;
	varyable[j]->val.appl.addr = memAddr;
	if(varyable[j]->val.appl.len == 0)
	  memAddr += 4;
	else
	  memAddr += 4*varyable[j]->val.appl.len;
      }
      nxl(); goto _end;
    }
    er(5); return 0;
  _end:
    return 1;
}

int assign(struct INSTR_LIST**, struct OPERAND**, int*);
int condit(struct INSTR_LIST**);
int loopop(struct INSTR_LIST**);
int readop(struct INSTR_LIST**);
int writeop(struct INSTR_LIST**);

int oper(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  // ᨢ 㪠⥫  ஬ ࠭
  struct OPERAND* opdArray[32];
  int iArray = 0;
  *iListPtrPtr = NULL; // ।塞  楯 
  _0:
    if(assign(iListPtrPtr, opdArray, &iArray)) {goto _end;}
    if(condit(iListPtrPtr)) {goto _end;}
    if(loopop(iListPtrPtr)) {goto _end;}
    if(lc==KWSKIP) {
      //   
      struct INSTRUCTION *tmpInstr =
	INSTRUCTION_constructor(emptyOpc, NULL, NULL, NULL);
      //    㦥 ᮧ ᯨ 
      INSTR_LIST_append(iListPtrPtr, tmpInstr);
      nxl(); goto _end;
    }
    if(lc==KWABORT) {
      //   ਩ 室
      struct INSTRUCTION *tmpInstr =
	INSTRUCTION_constructor(exitOpc, NULL, NULL, NULL);
      //    㦥 ᮧ ᯨ 
      INSTR_LIST_append(iListPtrPtr, tmpInstr);
      nxl(); goto _end;
    }
    if(readop(iListPtrPtr)) {goto _end;}
    if(writeop(iListPtrPtr)) {goto _end;}
    return 0;
  _end:
    return 1;
}

int defset(struct INSTR_LIST**, struct OPERAND*);

int condit(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  struct OPERAND *endCaseLabel;
  *iListPtrPtr = NULL; // ।塞  楯 
  _0:
    if(lc==KWCASE) {
      endCaseLabel = CreateLabel();
      nxl(); goto _1;
    }
    return 0;
  _1:
    if(defset(iListPtrPtr, endCaseLabel)) {
      // ନ㥬 EXIT 
      struct INSTRUCTION* tmpInstr =
	INSTRUCTION_constructor(exitOpc, NULL, NULL, NULL);
	INSTR_LIST_append(iListPtrPtr, tmpInstr);
      // 塞  楯窥   
	INSTR_LIST_append(iListPtrPtr, endCaseLabel->val.label);
      goto _2;
    }
    if(lc==KWEND) {
      // ନ㥬 EXIT 
      struct INSTRUCTION* tmpInstr =
	INSTRUCTION_constructor(exitOpc, NULL, NULL, NULL);
	INSTR_LIST_append(iListPtrPtr, tmpInstr);
      nxl(); goto _end;
    }
    er(6); return 0;
  _2:
    if(lc==KWEND) {nxl(); goto _end;}
    er(6); return 0;
  _end:
    return 1;
}

int loopop(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  struct INSTR_LIST *tmpInstrListPtr;
  struct OPERAND *endLoopLabel;
  *iListPtrPtr = NULL;
  _0:
    if(lc==KWLOOP) {
      endLoopLabel = CreateLabel();
      nxl(); goto _1;
    }
    return 0;
  _1:
    if(defset(&tmpInstrListPtr, endLoopLabel)) {
      // 塞  楯窥   砫 横
      INSTR_LIST_append(iListPtrPtr, endLoopLabel->val.label);
      // 塞 ࠭塞  ⥫ 横
      INSTR_LIST_cat(iListPtrPtr, tmpInstrListPtr);
      goto _2;
    }
    if(lc==KWEND) {
      // ନ㥬 EMPTY 
      struct INSTRUCTION* tmpInstr =
	INSTRUCTION_constructor(emptyOpc, NULL, NULL, NULL);
	INSTR_LIST_append(iListPtrPtr, tmpInstr);
      nxl(); goto _end;
    }
    er(7); return 0;
  _2:
    if(lc==KWEND) {nxl(); goto _end;}
    er(7); return 0;
  _end:
    return 1;
}

int defens(struct INSTR_LIST**, struct OPERAND*);

int defset(iListPtrPtr, extLabel)
  struct INSTR_LIST **iListPtrPtr;
  struct OPERAND* extLabel;
{
  struct INSTR_LIST *tmpInstrListPtr;
  *iListPtrPtr = NULL;
  _0:
    if(defens(&tmpInstrListPtr, extLabel)) {
      INSTR_LIST_cat(iListPtrPtr, tmpInstrListPtr);
      goto _1;
    }
    return 0;
  _1:
    if(lc==KWOR) {nxl(); goto _2;}
    goto _end;
  _2:
    if(defens(&tmpInstrListPtr, extLabel)) {
      INSTR_LIST_cat(iListPtrPtr, tmpInstrListPtr);
      goto _1;
    }
    er(8); return 0;
  _end:
    return 1;
}

int expr(struct INSTR_LIST**);

int defens(iListPtrPtr, extLabel)
  struct INSTR_LIST **iListPtrPtr;
  struct OPERAND *extLabel;
{
  struct INSTR_LIST* tmpInstrListPtr1;
  struct INSTR_LIST* tmpInstrListPtr2;
  struct OPERAND *tmpOpdPtr1;
  struct OPERAND *tmpOpdPtr2;
  struct INSTRUCTION *tmpInstr;
  *iListPtrPtr = NULL;
  _0:
    if(expr(&tmpInstrListPtr1)) {
      //  ࠭ ࠦ
      tmpOpdPtr1 = tmpInstrListPtr1->lastOpd;
      // ନ஢ 砫 ᯨ᪠    ᫮
      *iListPtrPtr = tmpInstrListPtr1;
      tmpInstrListPtr1 = NULL; // ⮢    ஢
      goto _1;
    }
    return 0;
  _1:
    if(lc==STRELA) {nxl(); goto _2;}
    er(9); return 0;
  _2:
    if(oper(&tmpInstrListPtr2)) {
      //   ஢ ᫮
      INSTR_LIST_cat(&tmpInstrListPtr1, tmpInstrListPtr2);
      goto _3;
    }
    er(9); return 0;
  _3:
    if(lc==PCL) {nxl(); goto _2;}
    goto _end;
  _end:
    // ନ஢ ࠬ    ᫮  ⪨ ୠ⨢
    //  室 ᫥ 믮 ᫮
    tmpInstr = INSTRUCTION_constructor(gotoOpc, extLabel, NULL, NULL);
    INSTR_LIST_append(&tmpInstrListPtr1, tmpInstr);
    //  ࠭ - 
    tmpOpdPtr2 = CreateLabel();
    INSTR_LIST_append(&tmpInstrListPtr1, tmpOpdPtr2->val.label);
    //  ᫮
    tmpInstr = INSTRUCTION_constructor(ifOpc, tmpOpdPtr1, tmpOpdPtr2, NULL);
    INSTR_LIST_append(iListPtrPtr, tmpInstr);
    INSTR_LIST_cat(iListPtrPtr, tmpInstrListPtr1);
    return 1;
}

int addit(struct INSTR_LIST**);

int expr(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  opcType opc; // ࠡ뢠 
  struct OPERAND *tmpOpdPtr;
  struct OPERAND *tmpOpdPtr1; //  ࠭
  struct INSTR_LIST *tmpListPtr1;
  struct INSTR_LIST *tmpListPtr2;
  *iListPtrPtr = NULL;
  _0:
    if(addit(&tmpListPtr1)) {
      //  ࢮ ࠭
      tmpOpdPtr1 = tmpListPtr1->lastOpd;
      // ନ஢ 砫 ᯨ᪠    㬬
      *iListPtrPtr = tmpListPtr1;
      goto _1;
    }
    return 0;
  _1:
    if(lc==LT) {
      opc = ltOpc;
      nxl(); goto _2;
    }
    if(lc==GT) {
      opc = gtOpc;
      nxl(); goto _2;
    }
    if(lc==EQ) {
      opc = eqOpc;
      nxl(); goto _2;
    }
    if(lc==NE) {
      opc = neOpc;
      nxl(); goto _2;
    }
    if(lc==GE) {
      opc = geOpc;
      nxl(); goto _2;
    }
    if(lc==LE) {
      opc = leOpc;
      nxl(); goto _2;
    }
    goto _end;
  _2:
    if(addit(&tmpListPtr2)) {
      struct INSTRUCTION *tmpInstr;
      // ନ஢ ४ 痢  ࠭
      // ନ ६ ࠭    ਬ
      // ਬ ࠭ ।  樨 
      tmpOpdPtr = OPERAND_constructor(tmpVarOpd, NULL);
      //   ࠧ鸞: > | < | = | != | >= | <=
      tmpInstr = INSTRUCTION_constructor(opc,
	    tmpOpdPtr1,
	    tmpListPtr2->lastOpd,
	    tmpOpdPtr
      );
      //    ᯨ , । 2- ᫠
      INSTR_LIST_append(&tmpListPtr2, tmpInstr);
      // ⥭ ᯨ᪮ 
      INSTR_LIST_cat(iListPtrPtr, tmpListPtr2);
      (*iListPtrPtr)->lastOpd = tmpOpdPtr;
      tmpOpdPtr1 = (*iListPtrPtr)->lastOpd;
      goto _1;
    }
    er(10); return 0;
  _end:
    return 1;
}

int slag(struct INSTR_LIST**);

int addit(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  opcType opc; // ࠡ뢠 
  struct OPERAND *tmpOpdPtr1; //  ࠭
  struct OPERAND *tmpOpdPtr;
  struct INSTR_LIST *tmpListPtr1;
  struct INSTR_LIST *tmpListPtr2;
  *iListPtrPtr = NULL;
  _0:
    if(slag(&tmpListPtr1)) {
      //  ࢮ ࠭
      tmpOpdPtr1 = tmpListPtr1->lastOpd;
      // ନ஢ 砫 ᯨ᪠    ᫠
      *iListPtrPtr = tmpListPtr1;
      goto _1;
    }
    return 0;
  _1:
    if(lc==ADD) {
      opc = addOpc;
      nxl(); goto _2;
    }
    if(lc==SUB) {
      opc = subOpc;
      nxl(); goto _2;
    }
    goto _end;
  _2:
    if(slag(&tmpListPtr2)) {
      struct INSTRUCTION *tmpInstr;
      // ନ஢ ४ 痢  ࠭
      // ନ ६ ࠭    ਬ
      // ਬ ࠭ ।  樨 
      tmpOpdPtr = OPERAND_constructor(tmpVarOpd, NULL);
      //   ࠧ鸞: + | -
      tmpInstr = INSTRUCTION_constructor(opc,
	    tmpOpdPtr1,
	    tmpListPtr2->lastOpd,
	    tmpOpdPtr
      );
      //    ᯨ ࠭
      INSTR_LIST_append(&tmpListPtr2, tmpInstr);
      // ⥭ ᯨ᪮ 
      INSTR_LIST_cat(iListPtrPtr, tmpListPtr2);
      (*iListPtrPtr)->lastOpd = tmpOpdPtr;
      tmpOpdPtr1 = (*iListPtrPtr)->lastOpd;
      goto _1;
    }
    er(14); return 0;
  _end:
    return 1;

}

int mnog(struct INSTR_LIST**);

int slag(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  opcType opc; // ࠡ뢠 
  struct OPERAND *tmpOpdPtr1; //  ࠭
  struct OPERAND *tmpOpdPtr;
  struct INSTR_LIST *tmpListPtr1;
  struct INSTR_LIST *tmpListPtr2;
  *iListPtrPtr = NULL;
  _0:
    if(mnog(&tmpListPtr1)) {
      //  ࢮ ࠭
      tmpOpdPtr1 = tmpListPtr1->lastOpd;
      // ନ஢ 砫 ᯨ᪠    ⥫
      *iListPtrPtr = tmpListPtr1;
      goto _1;
    }
    return 0;
  _1:
    if(lc==MUL) {
      opc = multOpc;
      nxl(); goto _2;
    }
    if(lc==DIV) {
      opc = divOpc;
      nxl(); goto _2;
    }
    if(lc==MOD) {
      opc = modOpc;
      nxl(); goto _2;
    }
    goto _end;
  _2:
    if(mnog(&tmpListPtr2)) {
      struct INSTRUCTION *tmpInstr;
      // ନ஢ ४ 痢  ࠭
      // ନ ६ ࠭    ਬ
      // ਬ ࠭ ।  樨 
      tmpOpdPtr = OPERAND_constructor(tmpVarOpd, NULL);
      //   ࠧ鸞: * | / | %
      tmpInstr = INSTRUCTION_constructor(opc,
	    tmpOpdPtr1,
	    tmpListPtr2->lastOpd,
	    tmpOpdPtr
      );
      //    ᯨ ࠭
      INSTR_LIST_append(&tmpListPtr2, tmpInstr);
      // ⥭ ᯨ᪮ 
      INSTR_LIST_cat(iListPtrPtr, tmpListPtr2);
      (*iListPtrPtr)->lastOpd = tmpOpdPtr;
      tmpOpdPtr1 = (*iListPtrPtr)->lastOpd;
      goto _1;
    }
    er(11); return 0;
  _end:
    return 1;
}

int term(struct INSTR_LIST**);

int mnog(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  *iListPtrPtr = NULL;
  _0:
    if(lc==SUB) {nxl(); goto _1;}
    if(term(iListPtrPtr)) {goto _end;}
    return 0;
  _1:
    if(term(iListPtrPtr)) {
      struct OPERAND *tmpOpdPtr;
      struct INSTRUCTION *tmpInstr;
      // ନ஢ ४ 痢  ࠭
      // ନ ६ ࠭    ਬ
      // ਬ ࠭ ।  樨 
      tmpOpdPtr = OPERAND_constructor(tmpVarOpd, NULL);
      //  "㭠 "
      tmpInstr = INSTRUCTION_constructor(minOpc,
	    (*iListPtrPtr)->lastOpd, NULL, tmpOpdPtr
      );
      //    ᯨ ࠭
      INSTR_LIST_append(iListPtrPtr, tmpInstr);
      // ନ஢ 室 ࠭ ᯨ᪠ 
      (*iListPtrPtr)->lastOpd = tmpOpdPtr;
      goto _end;
    }
    er(12); return 0;
  _end:
    return 1;
}

int numb(struct CONST**);
int varying(struct INSTR_LIST**);

int term(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  struct CONST *constPtr = NULL; // 㪠⥫  ନ㥬 ⠭
  struct OPERAND *tmpOpdPtr; // ६ 䨪 ࠭
  _0:
    if(numb(&constPtr)) {
      // ନ஢ ⠭⭮ ࠭  ⮣ ᯨ᪠ 
      tmpOpdPtr = OPERAND_constructor(constOpd, constPtr);
      // ନ஢  ᯨ᪠   ⠭
      *iListPtrPtr = INSTR_LIST_constructor(NULL, NULL, tmpOpdPtr);
      goto _end;
    }
    if(varying(iListPtrPtr)) {goto _end;}
    if(lc==LRB) {nxl(); goto _1;}
    return 0;
  _1:
    if(expr(iListPtrPtr)) { //  ନ஢ ࠦ
      goto _2;
    }
    er(13); return 0;
  _2:
    if(lc==RRB) {nxl(); goto _end;}
    er(13); return 0;
  _end:
    return 1;
}

int numb(constPtrPtr)
  struct CONST **constPtrPtr; // 㪠⥫  ନ㥬 ⠭
{
  _0:
    if(lc==INT) {
      *constPtrPtr = CONST_constructor(INTTYP, &unum);
      nxl(); goto _end;
    }
    if(lc==FLT) {
      *constPtrPtr = CONST_constructor(FLOATTYP, &dnum);
     nxl(); goto _end;
    }
    return 0;
  _end:
    return 1;
}

int varying(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  struct OPERAND *tmpOpdPtr; // ६ 䨪 ࠭
  struct application* tmpAppl; // ६ 䨪 ⥪ ६
  struct INSTR_LIST *tmpInstrListPtr; // ६ 㪠⥫  ᯨ᮪ 
  _0:
    if(lc==ID) { //  ६ ..  ⠡ 
      if(find(lv)) { // ᯮ짮  ⠡ 
	tmpAppl= &(p_find->val.appl); // ६ 䨪  㧫
	// ନ஢  ࠭ -  ६
	tmpOpdPtr = OPERAND_constructor(nameVarOpd, tmpAppl);
	// ନ஢  ᯨ᪠   ६
	*iListPtrPtr = INSTR_LIST_constructor(NULL, NULL, tmpOpdPtr);
      } else {er(20); return 0;}
      nxl(); goto _1;
    }
    return 0;
  _1:
    if(lc==LSB) {nxl(); goto _2;}
    goto _end;
  _2:
    if(expr(&tmpInstrListPtr)) {
      struct INSTRUCTION *tmpInstr;
      // ନ஢ ४ 痢  ࠭
      // ନ ६ ࠭    ਬ
      // ਬ ࠭ ।  樨 
      tmpOpdPtr = OPERAND_constructor(tmpVarOpd, NULL);
      //  뤥    
      tmpInstr = INSTRUCTION_constructor(indexOpc,
	    (*iListPtrPtr)->lastOpd,
	    tmpInstrListPtr->lastOpd,
	    tmpOpdPtr
      );
      // ⥭ ᯨ᪮    ६ 
      //  ࠦ
      INSTR_LIST_cat(iListPtrPtr, tmpInstrListPtr);
      //    ᯨ 
      INSTR_LIST_append(iListPtrPtr, tmpInstr);
      // ନ஢ । १ (࠭).
      (*iListPtrPtr)->lastOpd = tmpOpdPtr;
      free(tmpInstrListPtr); // 㤠 ᫥ ᯮ짮
      goto _3;
    }
    er(15); return 0;
  _3:
    if(lc==RSB) {nxl(); goto _end;}
    er(15); return 0;
  _end:
    return 1;
}

int assign(iListPtrPtr, opdArray, iArrayPtr)
  struct INSTR_LIST **iListPtrPtr;
  struct OPERAND* opdArray[];
  int* iArrayPtr;
{
  struct INSTR_LIST *tmpInstrPtr1;
  struct INSTR_LIST *tmpInstrPtr2;
  struct OPERAND    *tmpOpdPtr;
  *iListPtrPtr = NULL;
  _0:
    if(varying(&tmpInstrPtr1)) {
      struct INSTRUCTION *tmpInstr; // ⥫   ᢠ
      tmpOpdPtr = OPERAND_constructor(tmpVarOpd, NULL);
      opdArray[(*iArrayPtr)++]=tmpOpdPtr; // 䨪 ஬筮 ࠭
      // ନ㥬  ᢠ
      tmpInstr = INSTRUCTION_constructor(
		     assOpc, tmpOpdPtr, tmpInstrPtr1->lastOpd, NULL);
      //    㦥 ᮧ ᯨ 
      INSTR_LIST_append(&tmpInstrPtr1, tmpInstr);
      goto _1;
    }
    return 0;
  _1:
    if(lc==ASS) {
      *iArrayPtr = 0; // ॡ ஬ ࠭  砫
      nxl(); goto _2;
    }
    if(lc==CL) {nxl(); goto _3;}
    er(16); return 0;
  _2:
    if(expr(&tmpInstrPtr2)) {
      // ନ㥬  ᢠ
      struct INSTRUCTION *tmpInstr = INSTRUCTION_constructor(
	   assOpc, tmpInstrPtr2->lastOpd, opdArray[(*iArrayPtr)++], NULL);
      //    㦥 ᮧ ᯨ 
      INSTR_LIST_append(&tmpInstrPtr2, tmpInstr);
      // 塞   ࠢ  ନ஢ ᯨ᮪
      INSTR_LIST_cat(&tmpInstrPtr2, *iListPtrPtr);
      // 塞  ନ஢ ᯨ  
      INSTR_LIST_cat(&tmpInstrPtr2, tmpInstrPtr1);
      // ⥫ ᯨ᮪ ९ᢠ ࠬ
      *iListPtrPtr = tmpInstrPtr2;
      goto _end;
    }
    er(16); return 0;
  _3:
    if(assign(iListPtrPtr, opdArray, iArrayPtr)) {goto _4;}
    er(16); return 0;
  _4:
    if(lc==CL) {nxl(); goto _2;}
    er(16); return 0;
  _end:
    return 1;
}

int readop(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  struct INSTR_LIST *tmpListPtr = NULL;
  *iListPtrPtr = NULL;
  _0:
    if(lc==KWREAD) {nxl(); goto _1;}
    return 0;
  _1:
    if(varying(&tmpListPtr)) {
      //    । ६
      struct INSTRUCTION *tmpInstr =
	INSTRUCTION_constructor(inOpc, tmpListPtr->lastOpd, NULL, NULL);
      //    㦥 ᮧ ᯨ 
      INSTR_LIST_append(&tmpListPtr, tmpInstr);
      INSTR_LIST_cat(iListPtrPtr, tmpListPtr);
      goto _2;
    }
    er(17); return 0;
  _2:
    if(lc==CL) {
      nxl(); goto _1;
    }
    goto _end;
  _end:
    return 1;
}

int specif(struct INSTR_LIST**);

int writeop(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  struct INSTR_LIST *tmpListPtr; //  , 塞  ࠦ
  *iListPtrPtr = NULL; // 砫    write
  _0:
    if(lc==KWWRITE) {nxl(); goto _1;}
    return 0;
  _1:
    if(expr(&tmpListPtr)) {
      //   뢮 । ࠦ
      struct INSTRUCTION *tmpInstr =
	INSTRUCTION_constructor(outOpc, tmpListPtr->lastOpd, NULL, NULL);
      //    㦥 ᮧ ᯨ 
      INSTR_LIST_append(&tmpListPtr, tmpInstr);
      INSTR_LIST_cat(iListPtrPtr, tmpListPtr);
      goto _2;
    }
    if(specif(&tmpListPtr)) {
      // । 横  뢮  ࠢ饣 ᨬ
      //  뢮 㦥 ᣥ஢  ⢥ত ࠢ
      INSTR_LIST_cat(iListPtrPtr, tmpListPtr);
      goto _2;
    }
    er(17); return 0;
  _2:
    if(lc==CL) {nxl(); goto _1;}
    goto _end;
  _end:
    return 1;
}

int specif(iListPtrPtr)
  struct INSTR_LIST **iListPtrPtr;
{
  opcType opc; // ࠡ뢠 
  struct INSTR_LIST *tmpListPtr; //  , 塞  ࠦ
  struct INSTRUCTION *tmpInstr;
  struct CONST *constPtr;
  struct OPERAND *tmpOpdPtr;
  *iListPtrPtr = NULL;
  _0:
    if(lc==KWSPACE) {opc = spaceOutOpc; nxl(); goto _1;}
    if(lc==KWSKIP) {opc = skipOutOpc; nxl(); goto _1;}
    if(lc==KWTAB) {opc = tabOutOpc; nxl(); goto _1;}
    return 0;
  _1:
    if(expr(&tmpListPtr)) {
      //   뢮 । ࠢ饩 ᫥⥫쭮
      tmpInstr =
	 INSTRUCTION_constructor(opc, tmpListPtr->lastOpd, NULL, NULL);
      goto _end;
    }
    //  ⢥ ࠭ 室 ᮧ ⠭ = 1
    unum = 1;
    constPtr = CONST_constructor(INTTYP, &unum);
    // ନ஢ ⠭⭮ ࠭
    tmpOpdPtr = OPERAND_constructor(constOpd, constPtr);
    //   뢮 । ࠢ饩 ᫥⥫쭮
    tmpInstr =
    INSTRUCTION_constructor(opc, tmpOpdPtr, NULL, NULL);
    goto _end;
  _end:
    //    㦥 ᮧ ᯨ 
    INSTR_LIST_append(&tmpListPtr, tmpInstr);
    INSTR_LIST_cat(iListPtrPtr, tmpListPtr);
    return 1;
}

