 // Name: input.c
 // 09.09.96

 #include <assert.h>
 #include <conio.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <ctype.h>

 #include "crush.h"

 void input(int i)
   {
     Operand opd;
     Temp *index;
     Ident ident;
     Temp *temp;
     int length = 0;
     char *val_ptr;
     scalType type;
     char str[81];

     opd = oper_tab[instr_tab[i].arg1];
     switch (opd.type)
       {
         case nameVarOpd:
           ident   = ident_tab[opd.val.ident_num];
           length  = ident.len;
           type    = ident.type;
           val_ptr = &mem[ident.addr];
           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               type    = index->type;
               val_ptr = &mem[index->addr];
               free(index);
             }
           else error("Invalid index operands combination");
           break;

        default:
           error("Operand must be lvalue in operator 'read'");
       } // switch (opd.type)

     if (length)
       error("Varible in operator 'read' can`t be an array");

     do
       {
         puts("Enter number:");
         scanf("%80s", str);

         if ((type == int_type) ? str2int(str, val_ptr) :
                                  str2float(str, val_ptr)) break;

         puts("Incorrect number format ! \nContinue ? (y/n) ");
         if (tolower(getche()) == 'n')
           {
             puts("\nUser`s termination !");
             exit(1);
           }
         else puts("");
       }
     while (1);

   } // void input(int i)
