

/******************************************************************
 operand.c - । 㭪権 ࠡ⪨ ࠭
******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "main_c.h"
#include "main_t.h"
#include "main_e.h"

void er(int);

static int opdNum = 0; //  ࠭ ( 浪 ᮧ

//     ⠭
struct CONST *CONST_constructor(typ, val)
  scalType typ;
  void *val;
{
  struct CONST *constPtr;
  if((constPtr = (struct CONST*)malloc(sizeof(struct CONST)))==NULL)
  {
    er(23); exit(1);
  }
  constPtr->typ = typ;
  if(typ == INTTYP) constPtr->val.unum = *((int *)val);
  else if(typ == FLOATTYP) constPtr->val.fnum = *((float *)val);
  return constPtr;
}

//     ࠭
struct OPERAND *OPERAND_constructor(typ, val)
  opdType typ;
  void *val;
{
  struct OPERAND *opdPtr;

  int OPERAND_size = sizeof(struct OPERAND);
  if((opdPtr = (struct OPERAND*)malloc(OPERAND_size))==NULL)
  {
    er(23); exit(1);
  }
  opdPtr->ident = ++opdNum;
  opdPtr->typ = typ;
  opdPtr->next = NULL;
  switch(typ)
  {
    case constOpd:
      opdPtr->val.cons = (struct CONST *)val;
      break;
    case nameVarOpd:
      opdPtr->val.var = (struct application *)val;
      break;
    case tmpVarOpd:
      opdPtr->val.var = NULL; // ࣠  ᮤন । 
      break;
    default:
      opdPtr->val.var = NULL; //
  }
  OPD_LIST_append(&opdList, opdPtr);
  return opdPtr;
}

// 뢮 ᯨ᪠ ࠭  䠩
void OPD_LIST_out(list, outfil)
  struct OPD_LIST* list;
  FILE* outfil;
{
  struct OPERAND* p_tmp;
  fprintf(outfil, "\n    ᮪ ࠭:\n");
  if(list->last == NULL) {
    fprintf(outfil, "࠭ !\n");
    return;
  }
  p_tmp = list->last;
  do {
    char* typ;
    char* vec_scal;
    switch(p_tmp->next->typ) {
      case nameVarOpd:
	if(p_tmp->next->val.var->typ == INTTYP) typ = "int";
	else typ = "float";
	if(p_tmp->next->val.var->len == 0) vec_scal = "᪠";
	else vec_scal = "";
	fprintf(outfil, "%d:  ६, %s, %s,  = %d\n",
	  p_tmp->next->ident, typ, vec_scal, p_tmp->next->val.var->addr
	);
	break;
      case tmpVarOpd:
	fprintf(outfil, "%d: ஬筠 ६ ( ।)\n",
	  p_tmp->next->ident
	);
      /*
	if(p_tmp->next->val.var->typ == INTTYP) typ = "int";
	else typ = "float";
	if(p_tmp->next->val.var->len == 0) vec_scal = "᪠";
	else vec_scal = "";
	fprintf(outfil, "%d: ஬筠 ६, %s, %s\n",
	  p_tmp->next->ident, typ, vec_scal
	);
      */
	break;
      case constOpd:
	if(p_tmp->next->val.cons->typ == INTTYP) {
	  typ = "int";
	  fprintf(outfil, "%d: ⠭, %s, %d\n",
	    p_tmp->next->ident, typ, p_tmp->next->val.cons->val.unum
	  );
	} else {
	  typ = "float";
	  fprintf(outfil, "%d: ⠭, %s, %e\n",
	    p_tmp->next->ident, typ, p_tmp->next->val.cons->val.fnum
	  );
	}
	break;
      case labelOpd:
	fprintf(outfil, "%d: ⪠\n",
	  p_tmp->next->ident
	);
	break;
      default:
	fprintf(outfil, " ࠭ ⭠\n");
    }
    p_tmp = p_tmp->next;
  } while(p_tmp != list->last);
}

//  ࠭  ᯨ ࠭
void OPD_LIST_append(list, opdPtr)
  struct OPD_LIST* list;
  struct OPERAND*  opdPtr;
{
  if(list->last == NULL)
    opdPtr->next = opdPtr;
  else {
    opdPtr->next = list->last->next;
    list->last->next = opdPtr;
  }
    list->last = opdPtr;
}

//   砫쭠 ⠭ ࠭ ⪨
struct OPERAND* CreateLabel()
{
  struct INSTRUCTION* tmpInstrPtr; // 㪠⥫   - 
  // ᮧ ࠭ - ⪠
  struct OPERAND* tmpOpdPtr =
    OPERAND_constructor(labelOpd, NULL);
  //  - ⪠  ⭮   ࠭
  tmpInstrPtr = INSTRUCTION_constructor(labelOpc, tmpOpdPtr, NULL, NULL);
  tmpOpdPtr->val.label = tmpInstrPtr;
  return tmpOpdPtr;
}