 // Name: ilist.c
 // 29.08.96

 #include "crush.h"

 static Temp *index_list = 0, *last_index;

 void ins_index(Temp *ptr)
   {
     if (index_list)
       {
         ptr->prev = last_index;
         last_index->next = ptr;
       }
     else index_list = ptr;
     last_index = ptr;
   }

 Temp *get_index(int id)
   {
     Temp *ptr = index_list;
     while (ptr)
       if (ptr->id == id)
         {
           if (ptr->prev)
             ptr->prev->next = ptr->next;
           else
             index_list = ptr->next;

           if (ptr->next)
             ptr->next->prev = ptr->prev;
           else
             last_index = ptr->prev;

           return ptr;
         }
       else ptr = ptr->next;
     return 0;
   }
