

/******************************************************************/
/* main.c */
/******************************************************************/

#include     <string.h>
#include     <stdio.h>
#include     <alloc.h>

#include     "main_c.h"
#include     "main_t.h"
#include     "main_d.h"

void fprintlex(FILE*);
void nxsi(void);
void nxl(void);
int program(struct INSTR_LIST**);
void output(char *);

extern erFlag;

 char *names[4];
 char *exts[] = { ".ins", ".nam", ".opd", ".cnt", ".txt" };

void main(argc, argv) int argc; char *argv[];
{
  int i;
  if (argc != 3)
    {
      puts("Incorrect command format !");
      puts("Example: transl.exe <input_file.ext> <output_file>");
      return;
    }

  for (i = 0; i < 5; i++)
    if ((names[i] = (char*)malloc(strlen(argv[2])+4)) != 0)
      {
	strcpy(names[i], argv[2]);
	strcat(names[i], exts[i]);
      }
    else
      {
	puts(" 墠⠥ !");
	return;
      }

  if (!(infile = fopen(argv[1], "r")))
    {
      puts("Input file is absent !");
      return;
    }

  if (!(outfile = fopen(names[4], "w")))
    {
      printf("訡  䠩 %s!\n", names[4]);
      perror("Error");
      return;
    }

  line = 1;
  column = 0;

  //  ⮣ ᯨ᪠ ,  ஬  
  // , ᣥ஢  쭥襬 (INSTRUCTION_LIST_cat)
  last = 0;
  nxsi();
  nxl();
  if (program(&InstrListPtr) && !erFlag)
    puts("O`key!");
  else
    puts("Invalid program !");

  // 뢮 ନ஢ ᯨ᪠ 
  INSTR_LIST_out(InstrListPtr, names[0]);
  //   ⠬  ᫥騬 뢮 !!!   䥪 !

  // 뢮 ନ஢ ⠡ 
  output(names[1]);
  //   ⠬  ᫥騬 뢮 !!!   䥪 !

  // 뢮 ନ஢ ᯨ᪠ ࠭
  OPD_LIST_out(&opdList, names[2], names[3]);

  for (i = 0; i < 4; i++)
    free(names[i]);

  fclose(infile);
  fclose(outfile);
}


