

/******************************************************************
 operand.c - । 㭪権 ࠡ⪨ ࠭
******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <errno.h>
#include <string.h>
#include <assert.h>

#include "main_c.h"
#include "main_t.h"
#include "main_e.h"

void er(int);

static int opdNum = 0; //  ࠭ ( 浪 ᮧ

//     ⠭
struct CONST *CONST_constructor(typ, val)
  scalType typ;
  void *val;
{
  struct CONST *constPtr;
  if((constPtr = (struct CONST*)malloc(sizeof(struct CONST)))==NULL)
  {
    er(23); exit(1);
  }
  constPtr->typ = typ;
  if(typ == INTTYP) constPtr->val.unum = *((int *)val);
  else if(typ == FLOATTYP) constPtr->val.fnum = (float)*((double *)val);
  return constPtr;
}

//     ࠭
struct OPERAND *OPERAND_constructor(typ, val)
  opdType typ;
  void *val;
{
  struct OPERAND *opdPtr;

  int OPERAND_size = sizeof(struct OPERAND);
  if((opdPtr = (struct OPERAND*)malloc(OPERAND_size))==NULL)
  {
    er(23); exit(1);
  }
  opdPtr->ident = opdNum++;
  opdPtr->typ = typ;
  opdPtr->next = NULL;
  switch(typ)
  {
    case constOpd:
      opdPtr->val.cons = (struct CONST *)val;
      break;
    case nameVarOpd:
      opdPtr->val.var = (struct application *)val;
      break;
    case tmpVarOpd:
      opdPtr->val.var = NULL; // ࣠  ᮤন । 
      break;
    default:
      opdPtr->val.var = NULL; //
  }
  OPD_LIST_append(&opdList, opdPtr);
  return opdPtr;
}

// 뢮 ᯨ᪠ ࠭  䠩
void OPD_LIST_out(struct OPD_LIST *list, char *name_0, char *name_1)
{
  struct OPERAND* ptr;
  int handle_0, handle_1;
  int const_num = 0;

  if ((handle_0 = _creat(name_0, 32))<0)
    {
      printf("訡  䠩 %s!\n", name_0);
      perror("Error");
      return;
    }

  if ((handle_1 = _creat(name_1, 32))<0)
    {
      printf("訡  䠩 %s!\n", name_1);
      perror("Error");
      return;
    }

  fprintf(outfile, "\n\t\t᮪ ࠭:\n");

  if (!list->last)
    {
      fprintf(outfile, "    ࠭  !\n");
      _close(handle_0);
      _close(handle_1);
      return;
    }
  ptr = list->last;

  do
   {
    opdType type = ptr->next->typ;
    write(handle_0, &type, sizeof(type));

    switch (type) {
      char *str;

      case tmpVarOpd:
        write(handle_0, &ptr->next->ident, sizeof(int));
	fprintf(outfile, "%3d: ஬筠 ६ ( ।)\n",
	  ptr->next->ident);
	break;

      case nameVarOpd:
        write(handle_0, &ptr->next->val.var->typ, sizeof(int));
	fprintf(outfile, "%3d:  ६ %d\n",
	  ptr->next->ident, ptr->next->val.var->typ);
	break;

      case constOpd:
        write(handle_1, ptr->next->val.cons, sizeof(struct CONST));
        write(handle_0, &const_num, sizeof(int));
        if (ptr->next->val.cons->typ == INTTYP)
          {
            str = "int";
            fprintf(outfile, "%3d: ⠭ ⨯ %s = %d\n",
              ptr->next->ident, str, ptr->next->val.cons->val.unum);
          }
        else
          {
            str = "float";
            fprintf(outfile, "%3d: ⠭ ⨯ %s = %e\n",
              ptr->next->ident, str, ptr->next->val.cons->val.fnum);
          }
        const_num++;
        break;

      case labelOpd:
        write(handle_0, &ptr->next->val.label->opc, sizeof(int));
	fprintf(outfile, "%3d: ⪠  ப %d\n", ptr->next->ident,
          ptr->next->val.label->opc);
	break;

      default:
        assert(0);
    }
    ptr = ptr->next;

  } while (ptr != list->last);

  _close(handle_0);
  _close(handle_1);
}

//  ࠭  ᯨ ࠭
void OPD_LIST_append(list, opdPtr)
  struct OPD_LIST* list;
  struct OPERAND*  opdPtr;
{
  if(list->last == NULL)
    opdPtr->next = opdPtr;
  else {
    opdPtr->next = list->last->next;
    list->last->next = opdPtr;
  }
    list->last = opdPtr;
}

//   砫쭠 ⠭ ࠭ ⪨
struct OPERAND* CreateLabel()
{
  struct INSTRUCTION* tmpInstrPtr; // 㪠⥫   - 
  // ᮧ ࠭ - ⪠
  struct OPERAND* tmpOpdPtr =
    OPERAND_constructor(labelOpd, NULL);
  //  - ⪠  ⭮   ࠭
  tmpInstrPtr = INSTRUCTION_constructor(labelOpc, tmpOpdPtr, NULL, NULL);
  tmpOpdPtr->val.label = tmpInstrPtr;
  return tmpOpdPtr;
}