// table.cpp
// ।   table,
// 饣 樨  ⠡楩 
//  ᭮ ᫥⥫쭮 ᯨ᪠

#include <stdio.h>
#include <string.h>

#include "element.hpp"
#include "node.hpp"
#include "table.hpp"

int table::find(char* n) { //     ᯨ᪠
  if(last == 0) {// ⮢  ᯨ᪥ 
    return 0;
  }
  node* pTmp = last; // ६ 㪠⥫  ।騩 
  do { //      箬 n
    if(*(pTmp->next) == n) {// ᮢ 祩
      pFind = pTmp->next;
      preFind = pTmp; // preFind 㪠뢠  ।騩 㧥
      return 1;
    } else if(*(pTmp->next) < n) { //       㧫
      pTmp = pTmp->next; // 室  ᫥饬 㧫
    } else { //       㧫
      preFind = pTmp; // ।騩 
      pFind = pTmp->next; // 㧥, ᫥騩   砥
      return 0; //    ன ᫥, 訩 
    }
  } while(pTmp != last); // 襭  ⢨ 㧫
  pFind = 0; // 㪠⥫    
  preFind = last; // 砥  ᫥ ⮬
  return 0; //   
}

void table::incl(char* n) {// 祭   㪠 祬  ⠡
  element* pElem = new element(n);
  node* pTmp = new node(pElem);
  // 祭 㧫  ᯨ᮪:
  if(last == 0) {// ᯨ᮪ 
    last = pTmp; // ᫨  ᯨ᮪
    pTmp->next = last; // 㫨 
  } else  { // ⠢  ।騬
    pTmp->next = preFind->next; // 楯  ᫥騬
    preFind->next = pTmp; // 楯 ।⢥
    if(pFind == 0) // ७ ᫥
      // (᫨  ᪥ ன  ᯨ᮪)
      last = pTmp;
  }
}

void table::del(void) { // 㤠    ⠡
  if(pFind->next == pFind) {//  ᫥ 㧥  ᯨ᪥
    delete pFind;
    last = 0; // ᮧ ⮩ ᯨ᮪
  } else {// 㡨ࠥ  
    if(pFind == last) // 㤠 ᫥  ᯨ᪠
      last = preFind; // ।᫥ 㧥 ⠭ ᫥
    preFind->next = pFind->next;
    delete pFind;
  }
}

void table::out(void) { // 뢮 ⠡   ࠭
  printf("\n");
  if(last == 0) {
    printf("⠡  \n");
    return;
  }
  node* pTmp = last->next;
  do {
    pTmp->out();
    pTmp = pTmp->next;
  } while(pTmp != last->next);
}

void table::out(FILE* f) { // 뢮 ⠡   䠩
  if(last == 0) {
    fprintf(f, "⠡  \n");
    return;
  }
  node* pTmp = last->next;
  do {
    pTmp->out(f);
    pTmp = pTmp->next;
  } while(pTmp != last->next);
}

void table::reset(void) { // ⪠ ⠡
  if(last) {
    preFind = last; pFind = last->next;
    do {
      delete preFind;
      preFind = pFind;
      pFind = pFind->next;
    } while(pFind != last);
    last = 0;
  }
  pFind = preFind = 0;
}

